
"""
returns a list of legalmoves of the form (indes1,index2,amount)
vials=[["r","b"],["r","r","r"],["g","g","g"]]
"""
def getMoves(vials):
    for s in range(len(vials)):
        for e in range(len(vials)):
            if s==e:continue
            # actually moving
            
            if len(vials[s])==0:continue
            # something to move
            
            if not(len(vials[e])==0 or vials[s][-1]==vials[e][-1]):continue
            # top colors match
            
            if len(vials[e])>=4:continue
            # can move all or split
            color=vials[s][-1]
            curr=len(vials[s])-1
            while curr>=0 and vials[s][curr]==color:curr-=1
            if curr<0:
                count=len(vials[s])
            else:
                count=len(vials[s])-curr-1
            if count+len(vials[e])>4:
                count=4-len(vials[e]) # this fixes it
                continue # but really we don't care about this move anyway
            # amount to move is valid

            if len(vials[e])==0: # moving to empty vial
                if count==len(vials[s]):continue # don't move entire vial
                broken=True
                for o in range(len(vials)):
                    cs=set()
                    for c in vials[o]:
                        cs.add(c)
                    if len(cs)==1 and vials[o][0]==color: break # If there is a vial with only one color don't move same color to empty vial
                else:
                    # for loop is exhausted
                    broken=False
                if broken:
                    continue
            # dont waste time
            yield (s,e,count)
def applyMove(vials,m):
    for i in range(m[2]):
        vials[m[1]].append(vials[m[0]].pop())
def unapplyMove(vials,m):
    for i in range(m[2]):
        vials[m[0]].append(vials[m[1]].pop())
def serialize(vials):
    x=["".join(i) for i in vials]
    x.sort()
    return "|".join(x)
def solved(vials):
    count=0
    for vial in vials:
        if len(vial) not in (4,0): return False # Find full and empty vials
        colors=set()
        for color in vial:
            colors.add(color)
        if len(colors)>1: return False # That only have one color / or none if empty
        if len(colors)==1:count+=1
    return True

def solve(vials,states,c,a):
    if c==a:
        return None
    for move in getMoves(vials):
        applyMove(vials,move)
        if solved(vials):return [move]
        state=serialize(vials)
        if state not in states:
            states.add(state)
            x=solve(vials,states,c+1,a)
            if x:
                x.append(move)
                return x
        unapplyMove(vials,move)
    return None
def depthLimited(vials,a):
    states=set()
    x=solve(vials,states,0,a)
    if x:
        x.reverse()
        return x
    else:
        return None
def ids(vials):
    i=15
    a=depthLimited(vials,i)
    while not a:
        a=depthLimited(vials,i)
        i+=1
        print(i)
    return a
def pretty(moves):
    for move in moves:
        print("Move",move[0]+1,"to",move[1]+1)
        #input()
import copy
def main():
    #vials=[None]*int(input("How many vials? "))
    #for i in range(len(vials)):
    #    vials[i]=list(input("Contents of vial "+str(i+1)+" from bottom to top, one character each? "))
    #v2=copy.deepcopy(vials)
    vials=[["a","b","c","d"],["e","f","g","h"],["g","d","i","f"],["j","h","i","a"],["g","j","k","f"],["a","g","c","f"],["l","e","c","b"],["i","e","l","h"],["d","e","k","k"],["b","i","j","l"],["b","a","d","c"],["k","l","j","h"],[],[]]
    moves=ids(vials)
    print("Moves required:",len(moves))
    pretty(moves)
main()
